//move "p.canMomen" over from main to here
addHook("PlayerThink", function(p)
	if p.momentumDisableInit == "nil"
		p.momentumDisableInit = true
		p.disableMomen = 0 //debug
	else
		return
	end
end)
//i wonder what i broke now
local function SoapyMomentum(player, arg)
    if arg then
		if arg == "on" or arg == "1" or arg == "true"
			player.disableMomen = 0
			CONS_Printf(player, "Soap's momentum is ON")
		else
			player.disableMomen = 1
			CONS_Printf(player, "Soap's momentum is OFF!")
		end
	else
		if not player.isp.xmomentum
			if not player.disableMomen then
				CONS_Printf(player, "Toggles momentum for Soap. Currently on right now.")
			else
				CONS_Printf(player, "Toggles momentum for Soap. Currently off right now.")
			end
		else
			CONS_Printf(player, "You can't use this while p.xmomentum is loaded.")
		end
	end
end

COM_AddCommand("soap_momentum", function(player, arg)
	SoapyMomentum(player, arg)
end)


--thanks for CobaltBW for this code!!! ( https://mb.srb2.org/threads/the-momentum-mod.27233/ )
//should i make this into its own file?? it IS bigger than all of the scripts here
//yeah i think i should
addHook('ThinkFrame', do
	for player in players.iterate do
		if player.mo.skin ~= "soapthehedge"
			return
		end
		
		if player.mrcephys and player.xmo == "nil" then
			 player.mrcephys = 0
			 player.xmo = 0
		end
		
		if not player.isxmomentum then
			player.xmo = false
		else
			if player.isxmomentum then
				player.xmo = true
			end
		end
		
	/*	if p.mrce ~= "nil" then	
			if p.mrce.physics == "nil" or "false" then
				p.mrcephys = false
			else
				if p.mrce.physics then
					p.mrcephys = true
				end
			end
		else
			p.mrcephys = false
		end
		if p.mrce == "nil" then
			p.mrcephys = false
		else
			local pmrce = p.mrce
			if pmrce.physics then
				p.mrcephys = true
			else
				p.mrcephys = false
			end
		end
	*/
		if not player.mrce == "nil" then	
			if player.mrce.physics == "nil" or "false" then
				player.mrcephys = false
			else
				if player.mrce.physics then
					player.mrcephys = true
				end
			end
		else
			player.mrcephys = false
		end

		if player.mo.skin == "soapthehedge" and not player.xmo and not player.mrcephys then
			player.canMomen = true
		else
			player.canMomen = false
		end
	end
end)
local debug = 0

addHook('ThinkFrame', do
	for player in players.iterate do
		if player.mo and player.mo.scale and player.mo.friction and player.mo.movefactor and player.canMomen then
			local pmo = player.mo
			//Create history
			if player.waterlast == nil then
				player.waterlast = false
				player.dashlast = false
				player.realfriction = pmo.friction
			end
			local skin = skins[pmo.skin]
			
			//Stat adjust
			if player.charability2 == CA2_SPINDASH then
				player.mindash = skin.mindash * 3/2
			end
			local water = 1+(pmo.eflags&MFE_UNDERWATER)/MFE_UNDERWATER //Water factor for momentum halving
			local grounded = P_IsObjectOnGround(pmo)
			local nmom = skin.normalspeed //Skin normalspeed, the integral component
			//Dashmode overrides skin normalspeed
			if player.dashmode >= 3*TICRATE then
				nmom = player.normalspeed
			end
			
			local scale = pmo.scale //Normalspeed calculations are affected by scale
			local friction = FixedDiv(pmo.friction,pmo.movefactor) //Reversing friction is required for sustaining ground momentum
			local pmom = FixedDiv(FixedHypot(player.rmomx,player.rmomy),scale) //Current speed, scaled for normalspeed calculations
			local pwup = (player.powers[pw_sneakers]) or (player.powers[pw_super]) //Speed-ups multiply max allowed speed by 5/3
			local momangle = R_PointToAngle2(0,0,player.rmomx,player.rmomy) //Used for angling new momentum in ability cases
			//Adjust current speed reading for calculations with pwup status
			if pwup then
				pmom = $*3/5
			end
			local mom = FixedHypot(pmo.momx,pmo.momy)

						
			
			/////////
			//General momentum scaling
			
			//Do landing momentum cut
			if pmo.eflags&MFE_JUSTHITFLOOR then
				player.normalspeed = skin.normalspeed
				pmo.friction = $-$/10
			//Do ground momentum
			elseif grounded then
				//The amount of momentum to sustain
				local sustain = FixedDiv(min(pmom*water,nmom*2),friction)
-- 				if pmom > player.normalspeed then
					player.normalspeed = max(nmom,sustain)
-- 				end
			//Do air momentum
			elseif not(player.dashmode) then //Dashmode overrides normalspeed in the air
				player.normalspeed = skin.normalspeed
			end
			
			///////
			//Thok momentum scaling
-- 			if player.charability == CA_THOK
			if player.charability == CA_JUMPTHOK
				then
				//Raise thokspeed to current momentum if above innate actionspd
				player.actionspd = max(pmom*water,skin.actionspd)
			end
						
			//Update history
			player.waterlast = (pmo.eflags&MFE_UNDERWATER > 0)
			player.dashlast = (player.pflags&PF_STARTDASH > 0)
			
			//DEBUG//
			if debug then
				print("momz " + pmo.momz/FRACUNIT)
				print("actionspd   " + player.actionspd/FRACUNIT)
				print("pmom        " + pmom/FRACUNIT)
				print("normalspeed " + player.normalspeed/FRACUNIT)
			end
		end
	end
end)
